unit FormMain;

interface

uses
  kaWordBasicWrapper,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, DB, DBTables, Grids,
  DBGrids, ActnList, IBDatabase, IBCustomDataSet, IBQuery, IBSQL, IniFiles,
  FileCtrl, CheckLst, IBTable, Mask, DBCtrls, Menus, ImgList, ToolWin, SetReportsParam;

type
  // !!!         REF_RESULT_CODE  
  TResultCode = (rcSuccess = 1, rcUserTerminate = 2, rcTableOpenError = 3, rcTableInsertError = 4, rcTableUpdateError = 5);

  //     
  TObrabotkaResult = record
    ResultCode: TResultCode;
    countAll: Integer;
    countObrabotano: Integer;
    countInsert: Integer;
    countInsertErrors: Integer;
    countUpdate: Integer;
    countUpdateErrors: Integer;
    TableName: string;
  end;

  TfmMain = class(TForm)
    gbDataPreview: TGroupBox;
    Table: TTable;
    gridSrcTable: TDBGrid;
    DataSource: TDataSource;
    pcMain: TPageControl;
    tsParadox: TTabSheet;
    Panel1: TPanel;
    ActionList1: TActionList;
    actSelectSrcFile: TAction;
    OD: TOpenDialog;
    actObrabotkaFile: TAction;
    tsIB: TTabSheet;
    GroupBox2: TGroupBox;
    Panel2: TPanel;
    Button2: TButton;
    meIBDatabaseName: TMemo;
    actSelectIBDatabase: TAction;
    Panel3: TPanel;
    GroupBox3: TGroupBox;
    Splitter2: TSplitter;
    gbIBData: TGroupBox;
    lbIBTables: TListBox;
    DBGrid2: TDBGrid;
    IBQuery: TIBQuery;
    IBDatabase: TIBDatabase;
    readIBTransaction: TIBTransaction;
    odIB: TOpenDialog;
    DataSourceIB: TDataSource;
    sqlInsert: TIBSQL;
    sqlUpdate: TIBSQL;
    writeIBTransaction: TIBTransaction;
    actTerminateImport: TAction;
    sqlFind: TIBSQL;
    edSrcFileName: TCheckListBox;
    Panel4: TPanel;
    Splitter3: TSplitter;
    txtPath: TStaticText;
    FileList: TFileListBox;
    actExpertMode: TAction;
    actSimpleMode: TAction;
    sqlProtocolInStart: TIBSQL;
    sqlProtocolInInsert: TIBSQL;
    dsProtocolIn: TDataSource;
    dsProtocolInText: TDataSource;
    writeProtocol: TIBTransaction;
    sqlProtocolInDel: TIBSQL;
    ibqProtocolIn: TIBQuery;
    ibqProtocolInText: TIBQuery;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    ImageList: TImageList;
    actExportToServer: TAction;
    GroupBox1: TGroupBox;
    Splitter4: TSplitter;
    gridProtocolIN: TDBGrid;
    GroupBox4: TGroupBox;
    gridRotocolInText: TDBGrid;
    Panel5: TPanel;
    txtProtocolInSrcPath: TDBEdit;
    Splitter1: TSplitter;
    GroupBox5: TGroupBox;
    Splitter5: TSplitter;
    sgProtocol: TStringGrid;
    txtPath2: TStaticText;
    actAbout: TAction;
    sqlLastexport: TIBSQL;
    sqlGetData: TIBSQL;
    Timer1: TTimer;
    actTerminateExport: TAction;
    pnlTop: TPanel;
    Label1: TLabel;
    Bevel1: TBevel;
    lblCurrentFile: TLabel;
    pbAll: TProgressBar;
    ProgressBar: TProgressBar;
    txtPath1: TStaticText;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    btnPrinyatFile: TToolButton;
    ToolButton2: TToolButton;
    lblCurOperation: TLabel;
    pcProtocol: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    gridProtocolOut: TDBGrid;
    Splitter6: TSplitter;
    GroupBox6: TGroupBox;
    gridProtocolOutText: TDBGrid;
    Panel6: TPanel;
    txtProtocolOutPath: TDBEdit;
    sqlProtocolOutStart: TIBSQL;
    sqlProtocolOutDel: TIBSQL;
    sqlProtocolOutInsert: TIBSQL;
    ibqProtocolOut: TIBQuery;
    dsProtocolOut: TDataSource;
    ibqProtocolOutText: TIBQuery;
    dsProtocolOutText: TDataSource;
    actReport1: TAction;
    N11: TMenuItem;
    actReport10: TAction;
    N101: TMenuItem;
    N12: TMenuItem;
    actSettings: TAction;
    actReport2: TAction;
    N21: TMenuItem;
    actReport3: TAction;
    N31: TMenuItem;
    actReport4: TAction;
    N41: TMenuItem;
    procedure actSelectSrcFileExecute(Sender: TObject);
    procedure actObrabotkaFileExecute(Sender: TObject);
    procedure actSelectIBDatabaseExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbIBTablesDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actTerminateImportExecute(Sender: TObject);
    procedure edSrcFileNameClick(Sender: TObject);
    procedure actExpertModeExecute(Sender: TObject);
    procedure pcMainGetImageIndex(Sender: TObject; TabIndex: Integer;
      var ImageIndex: Integer);
    procedure actSimpleModeExecute(Sender: TObject);
    procedure IBDatabaseAfterConnect(Sender: TObject);
    procedure actAboutExecute(Sender: TObject);
    procedure actExportToServerExecute(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure actTerminateExportExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure actReport1Execute(Sender: TObject);
    procedure actReport10Execute(Sender: TObject);
    procedure actSettingsExecute(Sender: TObject);
    procedure actReport2Execute(Sender: TObject);
    procedure actReport3Execute(Sender: TObject);
    procedure actReport4Execute(Sender: TObject);
  private
    { Private declarations }
    ini: TIniFile;
    isTerminate: Boolean;
    prev_db_path, prev_table_name: string;
    TableName: string;
    isUpdate: Boolean;
    ProtocolInID: Integer;
    ProtocolOutID: Integer;
    ExportPath: string;
    CurExportPath: string;
    AppPath: string;
    ImportPath: string;
    ExportTemplateTablePath: string;
    CloseQuery: Boolean;
    DateTimePath: string;
    sql: TIBQuery;
    MSWord: TkaWordBasicWrapper;
    params: TfmSetReportParam;

    function SelectIBDatabase(DBName: string; isNew: Boolean = False): boolean;
    procedure OpenIBDatabase(FullDBName: string);
    function NeedUpdate: boolean;
    function ExtractFromArchive(arcFullName: string): string;
    procedure OpenSrcTable(srcFullName: string);
    function CheckForBadDocument: integer;
    procedure PrinyatFile(srcFullFileName: string; var Result: TObrabotkaResult);
    procedure ProtocolInStart(srcPath: string);
    procedure ProtocolInInsert(Result: TObrabotkaResult);
    procedure ProtocolInDel(aProtocolInID: Integer);
    procedure ExportToServer;
    function ExportToServerTable(aTableName: string; LastExportDate: TDateTime): integer;
    function PrepareTableForExport(aTableName: string): boolean;
    procedure ProtocolOutStart(aCurExportPath: string);
    procedure ProtocolOutInsert(Result: TObrabotkaResult);
    procedure ProtocolOutDel(aProtocolOutID: Integer);
    procedure PackToArchive(Path: string);
    procedure RecalcIndex;
    procedure DoReport(ReportNo: integer);
    procedure FillReport1;
    procedure FillReport2;
    procedure FillReport3;
    procedure FillReport4;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

uses Report10Params, DateUtils, FormWait, FormMainParams, FormExportParams;


{$R *.dfm}


procedure TfmMain.actSelectSrcFileExecute(Sender: TObject);
var
  i: integer;
  ext: string;
  srcPath: string;
begin
  OD.FileName := ini.ReadString('Paths', 'src', '');
  if OD.FileName = '' then OD.FileName := ImportPath + '*.w2s';

  if not OD.Execute then Exit;
  ini.WriteString('Paths', 'src', OD.FileName);
  ext := LowerCase(ExtractFileExt(OD.FileName));
  edSrcFileName.Items.Clear;
  if (ext = '.w2s')or(ext = '.rar') then
  begin
    srcPath := ExtractFromArchive(OD.FileName);
    FileList.Mask := '*.db';
    FileList.ApplyFilePath(srcPath);
    edSrcFileName.Items.AddStrings(FileList.Items);
//    OD.Files.AddStrings(FileList.Items);
//    OD.FileName := '*.db';
//    OD.InitialDir := srcPath;
//    if not OD.Execute then Exit;
  end
  else if ext = '.db' then
  begin
    srcPath := ExtractFilePath(OD.FileName);
    edSrcFileName.Items.AddStrings(OD.Files);
  end
  else if (MessageDlg('  !    ?', mtWarning, [mbYes, mbCancel], 0) = mrCancel) then Exit;

  for i := 0 to edSrcFileName.Items.Count - 1 do
  begin
    edSrcFileName.Items[i] := ExtractFileName(edSrcFileName.Items[i]);
    edSrcFileName.Checked[i] := True;
  end;
  edSrcFileName.ItemIndex := 0;
  OpenSrcTable(edSrcFileName.Items[0]);
  txtPath.Caption := srcPath;
  txtPath1.Caption := srcPath;
  txtPath2.Caption := srcPath;
  actObrabotkaFile.Enabled := True;
  if (MessageDlg('   .  ?', mtConfirmation, [mbYes, mbCancel], 0) = mrYes)
  then actObrabotkaFileExecute(nil);
end;

procedure TfmMain.actObrabotkaFileExecute(Sender: TObject);
var
  f: Integer;
  Result, ResultAll: TObrabotkaResult;
  cnt_person, cnt_uspeh, cnt_error_insert, cnt_error_update: Integer;
  res: string;
  tmpSql: TIBSql;
  cntBadDocument: integer;
begin
  if edSrcFileName.SelCount = 0 then
  begin
    MessageDlg('    .', mtInformation, [mbOk], 0);
    Exit;
  end;

  if not IBDatabase.Connected then
  begin
    if MessageDlg('   .  ?', mtConfirmation, [mbYes, mbCancel], 0) = mrCancel then Exit;
    try
      actSelectIBDatabase.Execute;
    except
      Exit;
    end;
  end;
  cntBadDocument := CheckForBadDocument;
  if cntBadDocument > 0 then
  begin
    if MessageDlg(' ' + IntToStr(cntBadDocument)
                  + '     .'
                  + #13#10'   ?', mtConfirmation, [mbYes, mbCancel], 0) = mrCancel then Exit;
  end;
  lblCurOperation.Caption := '!    ...';
//  Timer1.Enabled := True;
  edSrcFileName.Enabled := False;
  btnPrinyatFile.Action := actTerminateImport;
  actSelectSrcFile.Enabled := False;
  actObrabotkaFile.Enabled := False;
  pball.Min := 0;
  pball.Max := 0;
  for f := 0 to edSrcFileName.Items.Count - 1 do
    if edSrcFileName.Checked[f] then pball.Max := pball.Max + 1;
  pball.Position := 0;
  pball.Step := 1;
  writeIBTransaction.StartTransaction;
  ProtocolInStart(txtPath.Caption);
  sgProtocol.RowCount := 2;
  sgProtocol.Rows[1].Clear;
  tmpSql := TIBSQL.Create(Self);
  tmpSql.Transaction := readIBTransaction;
  try
   try
    for f := 0 to edSrcFileName.Items.Count - 1 do
    begin
      if not edSrcFileName.Checked[f] then Continue;
      edSrcFileName.ItemIndex := f;

//      if sgProtocol.Cols[0].IndexOf(edSrcFileName.Items[f]) >= 0 then
//        if MessageDlg('  "' + edSrcFileName.Items[f] + '"       .'#13#13' ?', mtConfirmation, [mbYes, mbCancel], 0) = mrCancel then Continue;

      PrinyatFile(StringReplace(txtPath.Caption + '\' + edSrcFileName.Items[f], '\\', '\', [rfReplaceAll]), Result);

      if sgProtocol.Rows[1][0] <> '' then sgProtocol.RowCount := sgProtocol.RowCount + 1;
      sgProtocol.Cols[0][sgProtocol.RowCount-1] := edSrcFileName.Items[f];
      sgProtocol.Cols[1][sgProtocol.RowCount-1] := IntToStr(Result.countAll);
      sgProtocol.Cols[2][sgProtocol.RowCount-1] := IntToStr(Result.countObrabotano);
      sgProtocol.Cols[3][sgProtocol.RowCount-1] := IntToStr(Result.countInsert);
      sgProtocol.Cols[4][sgProtocol.RowCount-1] := IntToStr(Result.countUpdate);
      ResultAll.countAll := ResultAll.countAll + Result.countAll;
      ResultAll.countObrabotano := ResultAll.countObrabotano + Result.countObrabotano;
      ResultAll.countInsert := ResultAll.countInsert + Result.countInsert;
      ResultAll.countInsertErrors := ResultAll.countInsertErrors + Result.countInsertErrors;
      ResultAll.countUpdate := ResultAll.countUpdate + Result.countUpdate;
      ResultAll.countUpdateErrors := ResultAll.countUpdateErrors + Result.countUpdateErrors;
      res := '';
      if (Result.countInsertErrors + Result.countUpdateErrors) = 0 then res := '.'
      else
      begin
        if (Result.countInsertErrors > 0)then res := res + '  :' + IntToStr(Result.countInsertErrors) + '. ';
        if (Result.countUpdateErrors > 0)then res := res + '  :' + IntToStr(Result.countUpdateErrors) + '. ';
      end;
      case Result.ResultCode of
        rcUserTerminate: res := ' .';
        rcTableOpenError: res := '  .';
      end;
      sgProtocol.Cols[5][sgProtocol.RowCount-1] := res;
      sgProtocol.Row := sgProtocol.RowCount-1;
      pball.StepIt;
      ProtocolInInsert(Result);
      if Result.ResultCode = rcUserTerminate then Break;
    end;
    if Result.ResultCode = rcUserTerminate then
    begin
      writeIBTransaction.Rollback;
      ProtocolInDel(ProtocolInID);
      MessageDlg('    .'#13'', mtInformation, [mbok], 0);
    end
    else
    begin
      RecalcIndex;
      writeIBTransaction.Commit;
      res := ' .';
      if (ResultAll.countInsertErrors + ResultAll.countUpdateErrors) = 0 then res := res + #13'.'
      else
      begin
        if ResultAll.countInsertErrors > 0 then res := res + #13'  :' + IntToStr(ResultAll.countInsertErrors) + '.';
        if ResultAll.countUpdateErrors > 0 then res := res + #13'  :' + IntToStr(ResultAll.countUpdateErrors) + '.';
      end;
      tmpSql.SQL.Text := 'select count(*) from person';
      tmpSql.ExecQuery;
      res := res + #13#13' :'#13'  ' + tmpSql.Fields[0].AsString + ' .';
      tmpSql.Close;

      tmpSql.SQL.Text := 'select count(*) from document';
      tmpSql.ExecQuery;
      res := res + #13'  ' + tmpSql.Fields[0].AsString + '   :';
      tmpSql.Close;

      tmpSql.SQL.Text := 'select count(*) from primaryinspection';
      tmpSql.ExecQuery;
      res := res + #13'    ' + tmpSql.Fields[0].AsString + '   .';
      tmpSql.Close;

      tmpSql.SQL.Text := 'select count(*) from scriningcard';
      tmpSql.ExecQuery;
      res := res + #13'    ' + tmpSql.Fields[0].AsString + '  .';
      tmpSql.Close;

      MessageDlg(res, mtInformation, [mbok], 0);
    end;
  except
    on e:Exception do
    begin
      if writeIBTransaction.Active then writeIBTransaction.Rollback;

      MessageDlg('       .'
                +#13'   [OK],    .'#13
                +#13' :'#13+e.Message, mtError, [mbOK], 0);
      actExpertModeExecute(nil);
    end;
  end;
  finally
//    Timer1.Enabled := False;
    lblCurOperation.Caption := '';
    edSrcFileName.Enabled := True;
    btnPrinyatFile.Action := actObrabotkaFile;
    actSelectSrcFile.Enabled := True;
    actObrabotkaFile.Enabled := True;
    lblCurrentFile.Caption := ' ';
    pbAll.Position := 0;
    ProgressBar.Position := 0;
    tmpSql.Free;
    if CloseQuery then Close;
  end;
end;

procedure TfmMain.actSelectIBDatabaseExecute(Sender: TObject);
begin
  SelectIBDatabase('', True);
end;

procedure TfmMain.OpenIBDatabase(FullDBName: string);
begin
  IBDatabase.Close;
  try
    IBDatabase.DatabaseName := FullDBName;
    IBDatabase.Open;
    IBDatabase.GetTableNames(lbIBTables.Items);
    meIBDatabaseName.Font.Color := clWindowText;
    actExportToServer.Enabled := True;
    ini.WriteString('Paths', 'ibDB', FullDBName);
  except
   on e:Exception do
   begin
     raise Exception.Create('   .'#13#13' :'#13+e.Message);
   end;
  end;
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
  CloseQuery := False;
  AppPath := ExtractFilePath(Application.ExeName);
  ExportPath := AppPath + 'Export\';
  ExportTemplateTablePath := AppPath + 'ExportTemplateTable\';
  ImportPath := AppPath + 'Import\';
  ForceDirectories(ImportPath);
  actSimpleModeExecute(nil);
  tsIB.TabVisible := False;
  pcMain.ActivePageIndex := 0;
  ini := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
  sgProtocol.Rows[0][0] := '';
  sgProtocol.Rows[0][1] := '';
  sgProtocol.Rows[0][2] := '';
  sgProtocol.Rows[0][3] := '';
  sgProtocol.Rows[0][4] := '';
  sgProtocol.Rows[0][5] := '';
end;

procedure TfmMain.lbIBTablesDblClick(Sender: TObject);
begin
  if lbIBTables.ItemIndex = -1 then Exit;
  IBQuery.Close;
  IBQuery.SQL.Text := 'select * from ' + lbIBTables.Items[lbIBTables.ItemIndex];
  IBQuery.Open;
  gbIBData.Caption := ': ' + lbIBTables.Items[lbIBTables.ItemIndex];
end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ini.Free;
  if IBDatabase.Connected then IBDatabase.Close;
  if Table.Active then Table.Close;
end;

procedure TfmMain.actTerminateImportExecute(Sender: TObject);
begin
  isTerminate := True;
end;

function TfmMain.NeedUpdate: boolean;
var fieldWstGID: TField;
    fieldUserGID: TField;
begin
  sqlFind.SQL.Text := 'select count(*) from ' + TableName;
  sqlFind.SQL.Append('where');

//  if TableName = 'CITY' then
//  begin
//    sqlFind.SQL.Append('citysoato = ''' + Table.FieldByName('citysoato').AsString + '''');
//  end
//  else
  begin
    sqlFind.SQL.Append(Table.Fields[0].FieldName + ' = ' + Table.Fields[0].AsString);
    fieldWstGID := Table.FindField('wstgid');
    if (fieldWstGID <> nil)and(fieldWstGID.Index > 0)
    then sqlFind.SQL.Append('and wstgid = ' + Table.FieldByName('wstgid').AsString);

    fieldUserGID := Table.FindField('usergid');
    if (fieldUserGID <> nil)and(fieldUserGID.Index > 0)
    then sqlFind.SQL.Append('and usergid = ' + Table.FieldByName('usergid').AsString);
  end;

  sqlFind.ExecQuery;
  Result := sqlFind.Fields[0].AsInteger > 0;
  sqlFind.Close;
end;

function TfmMain.ExtractFromArchive(arcFullName: string): string;
var fName, arcPath: string;
    rar, cmd: string;
    si: STARTUPINFO;
    pi: PROCESS_INFORMATION;
begin
  arcPath := ExtractFilePath(arcFullName);
  fName := arcPath + ChangeFileExt(ExtractFileName(arcFullName), '');
  rar := '"' + ExtractFilePath(ParamStr(0)) + '\rar.exe"';
  rar := StringReplace(rar, '\\', '\', [rfReplaceAll]);
  cmd := ' e -o+  "' + arcFullName + '" "' + fName + '\"';
  rar := rar + cmd;
  ZeroMemory(@si, SizeOf(si));
  si.cb := SizeOf(STARTUPINFO);
  si.dwFlags := STARTF_USESHOWWINDOW;
  si.wShowWindow := SW_HIDE;
  CreateProcess(nil, PAnsiChar(rar), nil, nil, false, CREATE_NEW_CONSOLE, nil, nil, si, pi);
  case WaitForSingleObject(pi.hProcess, 60000) of
    WAIT_FAILED,
    WAIT_TIMEOUT:
        begin
          actObrabotkaFile.Enabled := False;
          MessageDlg('    .', mtError, [mbOK], 0);
        end;
  else actObrabotkaFile.Enabled := True;
  end;
  CloseHandle(pi.hProcess);
  Result := fName;
end;

procedure TfmMain.OpenSrcTable(srcFullName: string);
begin
  Table.DisableControls;
try
  Table.Close;
  Table.DatabaseName := ExtractFilePath(srcFullName);
  Table.TableName := ExtractFileName(srcFullName);
//  Table.TableType := ttDBase;
  Table.Open;
finally
  Table.EnableControls;
end;
end;

procedure TfmMain.edSrcFileNameClick(Sender: TObject);
begin
  if edSrcFileName.ItemIndex = -1 then Exit;
  OpenSrcTable(edSrcFileName.Items[edSrcFileName.ItemIndex]);
end;

procedure TfmMain.PrinyatFile(srcFullFileName: string; var Result: TObrabotkaResult);
  procedure DoInsert;
  var
    i: Integer;
    s: string;
  begin
  try
//    sqlInsert.SQL.Text := 'insert into ' + TableName + ' values(';
//    s := '';
    for i := 0 to Table.Fields.Count - 1 do
      sqlInsert.Params[i].AsVariant := Table.Fields[i].AsVariant;
//    for i := 0 to Table.Fields.Count - 1 do
//    begin
//      if Table.Fields[i].AsString = '' then s := s + 'null'
//      else
//        case Table.Fields[i].DataType of
//          ftDate,
//          ftDateTime,
//          ftString: s := s + '''' + Table.Fields[i].AsString + '''';
//          ftBoolean: s := s + IntToStr(Integer(Table.Fields[i].AsBoolean));
//          ftFloat: s := s + FormatFloat('0.00####', Table.Fields[i].AsFloat);
//        else s := s + Table.Fields[i].AsString;
//        end;
//      if i < Table.Fields.Count - 1 then s := s + ',';
//    end;
//    sqlInsert.SQL.Append(s);
//    sqlInsert.SQL.Append(')');
    sqlInsert.ExecQuery;
    Inc(Result.countInsert);
  except
    Result.ResultCode := rcTableInsertError;
    Result.countInsertErrors := Result.countInsertErrors + 1;
  end;
  end;

  procedure DoUpdate;
  var
    fieldWstGID: TField;
    fieldUserGID: TField;
    i: Integer;
    s: string;
  begin
  try
    for i := 0 to Table.Fields.Count - 1 do
    begin
      sqlUpdate.Params[i].AsVariant := Table.Fields[i].AsVariant;
//      if Table.Fields[i].AsString = '' then sqlUpdate.Params[i].AsString := ''
//      else
//        case Table.Fields[i].DataType of
//          ftDate,
//          ftDateTime: sqlUpdate.Params[i].AsDateTime := Table.Fields[i].AsDateTime;
//          ftBoolean: sqlUpdate.Params[i].AsInteger := Table.Fields[i].AsInteger;
//          ftInteger: sqlUpdate.Params[i].AsInteger := Table.Fields[i].AsInteger;
//          ftFloat: sqlUpdate.Params[i].AsString := FormatFloat('0.000000', Table.Fields[i].AsFloat);
//        else sqlUpdate.Params[i].AsString := Table.Fields[i].AsString;
//        end;
    end;
    sqlUpdate.Params[i].AsInteger := Table.Fields[0].AsInteger;

    fieldWstGID := Table.FindField('wstgid');
    if (fieldWstGID <> nil)and(fieldWstGID.Index > 0)
    then sqlUpdate.ParamByName('wstgid').AsInteger := fieldWstGID.AsInteger;

    fieldUserGID := Table.FindField('usergid');
    if (fieldUserGID <> nil)and(fieldUserGID.Index > 0)
    then sqlUpdate.ParamByName('usergid').AsInteger := fieldUserGID.AsInteger;

    sqlUpdate.ExecQuery;
    Inc(Result.countUpdate);
  except
    Result.ResultCode := rcTableUpdateError;
    Result.countUpdateErrors := Result.countUpdateErrors + 1;
  end;
  end;
var
  fieldWstGID: TField;
  fieldUserGID: TField;
  ds: Char;
  s: string;
  i: Integer;
begin
  ds := DecimalSeparator;
  try
  DecimalSeparator := '.';
  //    
  Result.ResultCode := rcSuccess;
  Result.countAll := 0;
  Result.countObrabotano := 0;
  Result.countInsert := 0;
  Result.countInsertErrors := 0;
  Result.countUpdate  := 0;
  Result.countUpdateErrors  := 0;
  //   
  try
    OpenSrcTable(srcFullFileName);
  except
    Result.ResultCode := rcTableOpenError;
  end;

  if Result.ResultCode <> rcSuccess then Exit;

  // 
  TableName := UpperCase(ChangeFileExt(Table.TableName, ''));
  Result.TableName := TableName;
  lblCurrentFile.Caption := ' : ' + TableName;
  isTerminate := False;
  Table.DisableControls;
  //    
  sqlUpdate.SQL.Text := 'update ' + TableName + ' set';
  s := '';
  for i := 0 to Table.Fields.Count - 1 do
  begin
    s := s + Table.Fields[i].FieldName + '= :' + Table.Fields[i].FieldName;
    if i < Table.Fields.Count - 1 then s := s + ',';
  end;
  s := s + ', level2 = current_timestamp';
  sqlUpdate.SQL.Append(s);
  sqlUpdate.SQL.Append('where');
  sqlUpdate.SQL.Append(Table.Fields[0].FieldName + ' = :' + Table.Fields[0].FieldName);

  fieldWstGID := Table.FindField('wstgid');
  if (fieldWstGID <> nil)and(fieldWstGID.Index > 0)
  then sqlUpdate.SQL.Append('and wstgid = :wstgid');

  fieldUserGID := Table.FindField('usergid');
  if (fieldUserGID <> nil)and(fieldUserGID.Index > 0)
  then sqlUpdate.SQL.Append('and usergid = :usergid');
  sqlUpdate.Prepare;

  //  
  sqlInsert.SQL.Text := 'insert into ' + TableName + ' values(';
  s := '';
  for i := 0 to Table.Fields.Count - 1 do
  begin
    s := s + ':' + Table.Fields[i].FieldName;
    if i < Table.Fields.Count - 1 then s := s + ',';
  end;
  s := s + ', current_timestamp';
  sqlInsert.SQL.Append(s + ')');
  sqlInsert.Prepare;
try
  // -  
  Table.Last;
  Table.First;
  Result.countAll := Table.RecordCount;
  //  
  ProgressBar.Min := 0;
  ProgressBar.Max := Table.RecordCount;
  ProgressBar.Step := 1;
  ProgressBar.Position := 0;
  //  
  while not (Table.Eof or isTerminate) do
  begin
    if NeedUpdate then DoUpdate
    else DoInsert;
    Table.Next;
    ProgressBar.StepIt;
    Application.ProcessMessages;
    if isTerminate then
      if (MessageDlg('    ?', mtWarning, [mbYes, mbNo], 0) = mrNo)then
      begin
        isTerminate := False;
        CloseQuery := False;
      end;
  end;
finally
  if isTerminate then Result.ResultCode := rcUserTerminate;
  Result.countObrabotano := Table.RecNo;
  Table.EnableControls;
  lblCurrentFile.Caption := ' : ';
end;
finally
  DecimalSeparator := ds;
end;
end;


procedure TfmMain.actExpertModeExecute(Sender: TObject);
begin
  WindowState := wsMaximized;
  tsIB.TabVisible := True;
end;

procedure TfmMain.pcMainGetImageIndex(Sender: TObject; TabIndex: Integer;
  var ImageIndex: Integer);
begin
 //
end;

procedure TfmMain.actSimpleModeExecute(Sender: TObject);
begin
  Align := alTop;
  if Active then Align := alNone;
  WindowState := wsNormal;
  ClientHeight := pnlTop.Height + pcMain.TabHeight;
  tsIB.TabVisible := False;
end;

procedure TfmMain.ProtocolInInsert(Result: TObrabotkaResult);
begin
  writeProtocol.StartTransaction;
  try
  sqlProtocolInInsert.ParamByName('protocol_id').AsInteger := ProtocolInID;
  sqlProtocolInInsert.ParamByName('table_name').AsString := TableName;
  sqlProtocolInInsert.ParamByName('rec_count_all').AsInteger := Result.countAll;
  sqlProtocolInInsert.ParamByName('rec_count_obrabotano').AsInteger := Result.countObrabotano;
  sqlProtocolInInsert.ParamByName('rec_count_new').AsInteger := Result.countInsert;
  sqlProtocolInInsert.ParamByName('rec_count_update').AsInteger := Result.countUpdate;
  sqlProtocolInInsert.ParamByName('result_code').AsInteger := Integer(Result.ResultCode);
  sqlProtocolInInsert.ExecQuery;
  writeProtocol.Commit;
  ibqProtocolInText.Close;
  ibqProtocolInText.Open;
  ibqProtocolInText.Last;
  finally
  if writeProtocol.InTransaction then writeProtocol.Rollback;
  end;
end;

procedure TfmMain.ProtocolInStart(srcPath: string);
begin
  //      
  writeProtocol.StartTransaction;
  try
  sqlProtocolInStart.Params[0].AsString := srcPath;
  sqlProtocolInStart.ExecQuery;
  ProtocolInID := sqlProtocolInStart.Fields[0].AsInteger;
  writeProtocol.Commit;
  ibqProtocolIn.Close;
  ibqProtocolIn.Open;
  finally
  if writeProtocol.InTransaction then writeProtocol.Rollback;
  end;
  //
end;

procedure TfmMain.IBDatabaseAfterConnect(Sender: TObject);
begin
  readIBTransaction.StartTransaction;
  ibqProtocolIn.Open;
  ibqProtocolInText.Open;
  ibqProtocolOut.Open;
  ibqProtocolOutText.Open;
  actExportToServer.Enabled := True;
end;

procedure TfmMain.ProtocolInDel(aProtocolInID: integer);
begin
  writeProtocol.StartTransaction;
  try
  sqlProtocolInDel.Params[0].AsInteger := aProtocolInID;
  sqlProtocolInDel.ExecQuery;
  writeProtocol.Commit;
  ibqProtocolIn.Close;
  ibqProtocolIn.Open;
  finally
  if writeProtocol.InTransaction then writeProtocol.Rollback;
  end;
end;

procedure TfmMain.actAboutExecute(Sender: TObject);
begin
  MessageDlg('.     .'+#13+#10+''+#13+#10+' 1.0 ( ' + DateToStr(FileDateToDateTime(FileAge(Application.ExeName))) + ')', mtInformation, [mbOK], 0);
end;

function TfmMain.ExportToServerTable(aTableName: string; LastExportDate: TDateTime): integer;
var
  i,j: integer;
  Res: TObrabotkaResult;
begin
  aTableName := UpperCase(aTableName);
  Res.TableName := aTableName;
  if not PrepareTableForExport(aTableName) then Exit;
  Table.Close;
  Table.DatabaseName := CurExportPath;
  Table.TableName := aTableName + '.db';
  Table.Open;

  sqlGetData.Close;
  sqlGetData.SQL.Text := 'select count(*) from ' + aTableName;
  if Table.FindField(UpperCase('lastupdate')) <> nil then
  begin
    sqlGetData.SQL.Append(' where level2 > :last_export');
    sqlGetData.Params[0].AsDateTime := LastExportDate;
  end;
  sqlGetData.ExecQuery;
  ProgressBar.Position := 0;
  ProgressBar.Min := 0;
  ProgressBar.Max := sqlGetData.Fields[0].AsInteger;
  ProgressBar.Step := 1;
  Res.countUpdate := sqlGetData.Fields[0].AsInteger;
  Res.ResultCode := rcSuccess;
  Result := Res.countUpdate;

  sqlGetData.Close;
  sqlGetData.SQL.Text := 'select * from ' + aTableName;

  if Table.FindField(UpperCase('lastupdate')) <> nil then
  begin
    sqlGetData.SQL.Append(' where level2 > :last_export');
    sqlGetData.Params[0].AsDateTime := LastExportDate;
  end;
  sqlGetData.ExecQuery;

  Table.DisableControls;
  isTerminate := False;
  lblCurrentFile.Caption := ' : ' + aTableName;
try
  while not (sqlGetData.Eof or isTerminate) do
  begin
    Table.Insert;
    Table.Edit;
    for i := 0 to Table.FieldCount - 1 do
      Table.Fields[i].Value := sqlGetData.Fields[i].Value;
    Table.Post;
    sqlGetData.Next;
    ProgressBar.StepIt;
    Application.ProcessMessages;
    if isTerminate then
      if (MessageDlg('    ?', mtWarning, [mbYes, mbNo], 0) = mrNo)then
      begin
        isTerminate := False;
        CloseQuery := False;
      end
      else Res.ResultCode := rcUserTerminate;
  end;
  ProtocolOutInsert(Res);
finally
  Table.Close;
  Table.EnableControls;
  lblCurrentFile.Caption := ' : ';
end;
end;

procedure TfmMain.ExportToServer;
var
    i: integer;
    LastExportDate: TDateTime;
    Result: TObrabotkaResult;
    countAllNewRecords: Integer;
    tName: string;
    params: TfmExportParams;
begin
  params := TfmExportParams.Create(Application);
  try
    params.ShowModal;
    if params.rbLastExport.Checked then
    begin
      sqlLastexport.ExecQuery;
      LastExportDate := sqlLastexport.Fields[0].AsDateTime;
      sqlLastexport.Close;
    end
    else LastExportDate := params.edCustomExportDate.Date - 1;
  finally
    params.Free;
  end;
  DateTimePath := FormatDateTime('yyyy_mm_dd_hh_nn_ss', Now);
  CurExportPath := ExportPath + DateTimePath;
  if not ForceDirectories(CurExportPath) then
  begin
    MessageDlg('        : ' + CurExportPath, mtWarning, [mbOK], 0);
    Exit;
  end;
  btnPrinyatFile.Action := actTerminateExport;
  actSelectSrcFile.Enabled := False;
  actExportToServer.Enabled := False;
  lblCurOperation.Caption := '!     ...';
  try
  pbAll.Min := 0;
  pbAll.Position := 0;
  pbAll.Step := 1;
  FileList.Mask := '*.db;*.dbf';
  FileList.ApplyFilePath(ExportTemplateTablePath);
  pbAll.Max := FileList.Items.Count;
  ProtocolOutStart(CurExportPath);
try
  for i := 0 to FileList.Items.Count - 1 do
  begin
    tName := ChangeFileExt(FileList.Items[i], '');
    if lbIBTables.Items.IndexOf(tName) > -1
    then countAllNewRecords := countAllNewRecords + ExportToServerTable(tName, LastExportDate)
    else MessageDlg(' ' + tName + '     .', mtWarning, [mbOK], 0);
    pbAll.StepIt;
  end;
//
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('city', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('document', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('mapdiag', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('person', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('post', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('primaryinspection', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('primdiag', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('registrationarea', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('scriningcard', LastExportDate);
//  if not isTerminate then countAllNewRecords := countAllNewRecords + ExportToServerTable('street', LastExportDate);
  ibqProtocolOut.Close;
  ibqProtocolOut.Open;
  lblCurOperation.Caption := '!     ... ...';
  Application.ProcessMessages;
  PackToArchive(CurExportPath);
  if countAllNewRecords > 0 then MessageDlg(' . '+#13+#10+'        : ' +CurExportPath, mtInformation, [mbOK], 0)
  else MessageDlg('          : ' + DateToStr(LastExportDate)+#13+#10+'     .', mtWarning, [mbOK], 0);
except
  on e:Exception do
  begin
    ProtocolOutDel(ProtocolOutID);
    MessageDlg('      .'+#13+#10+''+#13+#10+' : ' + e.Message, mtError, [mbOK], 0);
  end;
end;
  finally
    lblCurOperation.Caption := '';
    btnPrinyatFile.Action := actObrabotkaFile;
    actSelectSrcFile.Enabled := True;
    actExportToServer.Enabled := True;
    pbAll.Position := 0;
    ProgressBar.Position := 0;
    if isTerminate then
    begin
      MessageDlg('      .', mtInformation, [mbOK], 0);
      ProtocolOutDel(ProtocolOutID);
    end;
  end;
end;

function TfmMain.PrepareTableForExport(aTableName: string): boolean;
var fileFrom, fileTo: string;
begin
  fileFrom := ExportTemplateTablePath + aTableName + '.db';
  fileTo := CurExportPath + '\' + aTableName + '.db';
  Result := CopyFile(PAnsiChar(fileFrom), PAnsiChar(fileTo), False);
  if not Result then
  begin
    MessageDlg('   -:' + 
               #13 + fileFrom + '    ' + ExportPath, mtWarning, [mbOK], 0);
    Exit;
  end;
end;

procedure TfmMain.actExportToServerExecute(Sender: TObject);
begin
  if not IBDatabase.Connected then
  begin
    MessageDlg('   .        .', mtWarning, [mbOK], 0);
    if not SelectIBDatabase('', True) then
    begin
      MessageDlg('      .  .', mtInformation, [mbOK], 0);
      Exit;
    end;
  end;
  ExportToServer;
end;

procedure TfmMain.Timer1Timer(Sender: TObject);
begin
  lblCurOperation.Visible := not lblCurOperation.Visible;
end;

procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CloseQuery := True;
  if btnPrinyatFile.Action = actTerminateImport then
  begin
    CanClose := False;
    actTerminateImportExecute(nil);
  end
  else if btnPrinyatFile.Action = actTerminateExport then
  begin
    CanClose := False;
    actTerminateExportExecute(nil);
  end
  else CanClose := True;
  if CanClose then CanClose := MessageDlg('   ?', mtConfirmation, [mbYes, mbCancel], 0) = mrYes;
end;

procedure TfmMain.actTerminateExportExecute(Sender: TObject);
begin
  isTerminate := True;
end;

procedure TfmMain.FormShow(Sender: TObject);
begin
  SelectIBDatabase(ini.ReadString('Paths', 'ibDB', ''));
end;

procedure TfmMain.ProtocolOutDel(aProtocolOutID: Integer);
begin
  writeProtocol.StartTransaction;
  try
    sqlProtocolOutDel.Params[0].AsInteger := aProtocolOutID;
    sqlProtocolOutDel.ExecQuery;
    writeProtocol.Commit;
    ibqProtocolOut.Close;
    ibqProtocolOut.Open;
  finally
    if writeProtocol.InTransaction then writeProtocol.Rollback;
  end;
end;

procedure TfmMain.ProtocolOutInsert(Result: TObrabotkaResult);
begin
  writeProtocol.StartTransaction;
  try
    sqlProtocolOutInsert.Params[0].AsInteger := ProtocolOutID;
    sqlProtocolOutInsert.Params[1].AsString := Result.TableName;
    sqlProtocolOutInsert.Params[2].AsInteger := Result.countUpdate;
    sqlProtocolOutInsert.Params[3].AsInteger := Integer(Result.ResultCode);
    sqlProtocolOutInsert.ExecQuery;
    writeProtocol.Commit;
    ibqProtocolOutText.Close;
    ibqProtocolOutText.Open;
  finally
    if writeProtocol.InTransaction then writeProtocol.Rollback;
  end;
end;

procedure TfmMain.ProtocolOutStart(aCurExportPath: string);
begin
  writeProtocol.StartTransaction;
  try
    sqlProtocolOutStart.Params[0].AsString := aCurExportPath;
    sqlProtocolOutStart.ExecQuery;
    ProtocolOutID := sqlProtocolOutStart.Fields[0].AsInteger;
    writeProtocol.Commit;
    ibqProtocolOut.Close;
    ibqProtocolOut.Open;
  finally
    if writeProtocol.InTransaction then writeProtocol.Rollback;
  end;
end;

function TfmMain.SelectIBDatabase(DBName: string; isNew: boolean): boolean;
var s: string;
    mr: TModalResult;
    uspeshno: Boolean;
begin

  meIBDatabaseName.Text := DBName;

  repeat
    try
      uspeshno := False;
      OpenIBDatabase(DBName);
      uspeshno := True;
    except
    begin
      uspeshno := False;
      s := '';
      if not isNew then s := '   .'+#13+#10+''+#13+#10;
      mr := MessageDlg(s + ' -   '+#13+#10+' -     '+#13+#10+' -   ', mtWarning, [mbYes, mbNo, mbCancel], 0);
      if mr = mrYes then
      begin
        odIB.FileName := AppPath + 'EMAG.GDB';
        Result := odIB.Execute;
        if not Result then Exit;
        meIBDatabaseName.Text := 'localhost:' + odIB.FileName;
        DBName := meIBDatabaseName.Text;
      end
      else if mr = mrNo then
      begin
        if InputQuery('   ', '   ', s) then
        begin
          meIBDatabaseName.Clear;
          meIBDatabaseName.Text := s + ':';
          s := '';
          if InputQuery('   ', '     ', s) then
          begin
            meIBDatabaseName.Clear;
            meIBDatabaseName.Text := meIBDatabaseName.Text + s;
            DBName := meIBDatabaseName.Text;
          end;
        end;
      end
      else break;
    end;
    end;
  until uspeshno;
end;

procedure TfmMain.PackToArchive(Path: string);
var si: STARTUPINFO;
    pi: PROCESS_INFORMATION;
    cmd: string;
begin
  cmd := '"' + AppPath + '\rar.exe" a -ep -m5 -md4096 -v1400k -df -vn "' + Path + '\' + DateTimePath + '.w2s" "' + Path + '\*.db"';
  cmd := StringReplace(cmd, '\\', '\', [rfReplaceAll]);
  GetStartupInfo(si);
  si.wShowWindow := SW_HIDE;
  if CreateProcess(nil, PAnsiChar(cmd), nil, nil, False, CREATE_NEW_CONSOLE, nil, nil, si, pi) then
  begin
    case WaitForSingleObject(pi.hProcess, 300000) of
      WAIT_FAILED,
      WAIT_TIMEOUT:
          begin
            MessageDlg('       5 .', mtError, [mbOK], 0);
          end;
    end;
    CloseHandle(pi.hProcess);
  end
  else MessageDlg('    .    .'+#13+#10+'        .', mtWarning, [mbOK], 0);
end;

procedure TfmMain.FormResize(Sender: TObject);
begin
  actExpertMode.Checked := WindowState = wsMaximized;
end;

procedure TfmMain.actReport1Execute(Sender: TObject);
begin
    DoReport(1);
end;

procedure TfmMain.actReport10Execute(Sender: TObject);
var i: Integer;
    params: TfmReport10Params;
    d1, d2: TDate;
    mu_name, period: string;
begin
  params := TfmReport10Params.Create(Application);
  try
  if params.ShowModal = mrCancel then Exit;
  d1 := StartOfAYear(YearOf(Date));
  case params.gbParams.ItemIndex of
    0: // 1 
      begin
        d2 := EndOfAMonth(YearOf(Date),3);
        period := 'I ';
      end;
    1: // 
      begin
        d2 := EndOfAMonth(YearOf(Date),6);
        period := '';
      end;
    2: // 9 
      begin
        d2 := EndOfAMonth(YearOf(Date),9);
        period := '9 ';
      end;
    3: // 
      begin
        d2 := EndOfAMonth(YearOf(Date),12);
        period := '';
      end;
    4: // 
      begin
        d1 := params.Date1.Date;
        d2 := params.Date2.Date;
        period := 'c ' + DateToStr(d1) + '  ' + DateToStr(d2);
      end;
  end;


  sql := TIBQuery.Create(nil);
  MSWord := TkaWordBasicWrapper.Create;
  Wait(True, ' ...');
  try
    SQL.Database := IBDatabase;
    SQL.sql.Text := 'select r.mu_name, h.mu from ref_params r left join hospital h on h.hspgid = r.mu_ref_id';
    SQL.Open;
    mu_name := SQL.Fields[1].AsString;

    if mu_name = '' then mu_name := SQL.Fields[0].AsString;

    SQL.sql.Text := 'select * from rpt_report10(:date_begin, :date_end)';
    SQL.Params[0].AsDate := d1;
    SQL.Params[1].AsDate := d2;
    SQL.Open;
    MSWord.Connect;
    MSWord.Hide;
    MSWord.CreateNewDocument(AppPath + 'Reports\  10.doc');
    MSWord.ReplaceText('< >', mu_name);
    MSWord.ReplaceText('<>', period);
    MSWord.FindText('<1>');
    i := 1;
    while not SQL.Eof do
    begin
      MSWord.TableInsertText([
                            IntToStr(i),
                            SQL.FieldByName('mu_name').AsString,
                            SQL.FieldByName('city_name').AsString,
                            SQL.FieldByName('count_all').AsString,
                            SQL.FieldByName('COUNT_VZROSLIE').AsString,
                            SQL.FieldByName('COUNT_DETI').AsString,
                            SQL.FieldByName('COUNT_PODROSTKI').AsString,
                            SQL.FieldByName('COUNT_VZROSLIE_S_GIPER').AsString,
                            SQL.FieldByName('COUNT_VZROSLIE_VPERVIE_AG').AsString,
                            SQL.FieldByName('COUNT_VZROSLIE_D_UCHET_VPERVIE').AsString,
                            SQL.FieldByName('COUNT_VZROSLIE_D_UCHET_AG').AsString,
                            SQL.FieldByName('DETI_POVISHEN_AD').AsString,
                            SQL.FieldByName('PODROSTKI_AG').AsString
                           ]);
      Inc(i);
      SQL.Next;
    end;
    //    
    MSWord.TableSelectRow;
    MSWord.CutSelection;
    Wait(False);
    MSWord.Show();
  finally
    Wait(False);
    SQL.Transaction.CommitRetaining;
    SQL.Free;
    MSWord.Free;
  end;
  finally
    params.Free;
  end;
end;

procedure TfmMain.actSettingsExecute(Sender: TObject);
var f: TfmMainParams;
begin
  f := TfmMainParams.Create(Application);
  try
   f.ShowModal;
  finally
    f.Free;
  end;
end;

procedure TfmMain.RecalcIndex;
var tmpSql1, tmpSql2: TIBSql;
begin
  tmpSql1 := TIBSQL.Create(self);
  tmpSql1.Transaction := readIBTransaction;
  tmpSql2 := TIBSQL.Create(self);
  tmpSql2.Transaction := writeIBTransaction;
  if not tmpSql2.Transaction.InTransaction then tmpSql2.Transaction.StartTransaction;
  try
  try
    tmpSql1.SQL.Text := 'select rdb$index_name from rdb$indices';
    tmpSql1.ExecQuery;
    while not tmpSql1.Eof do
    begin
      tmpSql2.SQL.Text := 'set statistics index ' + tmpSql1.Fields[0].AsString;
      lblCurOperation.Caption := '  ' + tmpSql1.Fields[0].AsString;
      lblCurOperation.Repaint;
      tmpSql2.ExecQuery;
      tmpSql1.Next;
    end;
//    tmpSql2.Transaction.Commit;
  except
//    tmpSql2.Transaction.Rollback;
  end;
  finally
    tmpSql1.Free;
    tmpSql2.Free;
  end;
end;

procedure TfmMain.DoReport(ReportNo: integer);
var sqlProcedureName: string;
    ReportTemplate: string;
begin
  if not Assigned(params)then params := TfmSetReportParam.Create(Application);
  if params.ShowModal = mrCancel then Exit;

  sql := TIBQuery.Create(nil);
  SQL.Database := IBDatabase;
  MSWord := TkaWordBasicWrapper.Create;
try
  case ReportNo of
    1: sqlProcedureName := 'RPT_REPORT1_BY_LIST';
    2: sqlProcedureName := 'RPT_REPORT2_BY_LIST';
    3: sqlProcedureName := 'RPT_REPORT3_BY_LIST';
    4: sqlProcedureName := 'RPT_REPORT4_BY_LIST';
  end;
  Wait(True, ' ...');

  SQL.SQL.Text := 'select * from ' + sqlProcedureName + '('
                + ':data_begin,'
                + ':data_end,'
                + ':city_name,'
                + ':uchastok_begin,'
                + ':uchastok_end,'
                + ':vozrast_min,'
                + ':vozrast_max,'
                + ':sex,'
                + ':wstgid)';
  SQL.Params[0].AsDate := params.edPeriodStart.Date;
  SQL.Params[1].AsDate := params.edPeriodEnd.Date;

  if params.chbCityAll.Checked then SQL.Params[2].AsString := ''
  else SQL.Params[2].AsString := params.qrCity.FieldByName('CITYNAME').AsString;

  if params.chbUchastokAll.Checked then
  begin
    SQL.Params[3].AsInteger := 0;
    SQL.Params[4].AsInteger := 1000;
  end
  else
  begin
    SQL.Params[3].AsInteger := StrToInt(params.edUchastokBegin.Text);
    SQL.Params[4].AsInteger := StrToInt(params.edUchastokEnd.Text);
  end;

  if params.chbVozrastAll.Checked then
  begin
    SQL.Params[5].AsInteger := 0;
    SQL.Params[6].AsInteger := 1000;
  end
  else
  begin
    SQL.Params[5].AsInteger := StrToInt(params.edVozrastBegin.Text);
    SQL.Params[6].AsInteger := StrToInt(params.edVozrastEnd.Text);
  end;

  if params.chbSexAll.Checked then SQL.Params[7].AsInteger := -1
  else if params.rbSexMale.Checked then SQL.Params[7].AsInteger := 1
  else if params.rbSexFemale.Checked then SQL.Params[7].AsInteger := 0;

  if params.chbHospitalAll.Checked then SQL.Params[8].AsInteger := -1
  else SQL.Params[8].AsInteger := params.qrHospitals.FieldByName('wstgid').AsInteger;

  SQL.Open;
  MSWord.Connect;
  MSWord.Hide;

  case ReportNo of
    1: ReportTemplate := '  1.doc';
    2: ReportTemplate := '  2.doc';
    3: ReportTemplate := '  3.doc';
    4: ReportTemplate := '  4.doc';
  end;

  MSWord.CreateNewDocument(AppPath + 'Reports\' + ReportTemplate);

  if params.chbHospitalAll.Checked
  then MSWord.ReplaceText('<>', ' ')
  else MSWord.ReplaceText('<>', params.qrHospitals.FieldByName('MU').AsString);

  MSWord.ReplaceText('< >', DateToStr(params.edPeriodStart.Date));
  MSWord.ReplaceText('< >', DateToStr(params.edPeriodEnd.Date));

  if params.chbCityAll.Checked then MSWord.ReplaceText('< >', ' ')
  else MSWord.ReplaceText('< >', params.qrCity.FieldByName('CITYNAME').AsString);

  if params.chbUchastokAll.Checked
  then MSWord.ReplaceText('<>', ' ')
  else MSWord.ReplaceText('<>', 'c ' + params.edUchastokBegin.Text + '  ' + params.edUchastokEnd.Text);

  if params.chbVozrastAll.Checked
  then MSWord.ReplaceText('<>', ' ')
  else MSWord.ReplaceText('<>', ' ' + params.edVozrastBegin.Text + '  ' + params.edVozrastEnd.Text);

  if params.chbSexAll.Checked
  then MSWord.ReplaceText('<>', '')
  else if params.rbSexMale.Checked then MSWord.ReplaceText('<>', '')
  else if params.rbSexFemale.Checked then MSWord.ReplaceText('<>', '');

  case ReportNo of
    1: FillReport1;
    2: FillReport2;
    3: FillReport3;
    4: FillReport4;
  end;
finally
  Wait(False);
  MSWord.Show;
  sql.Close;
  FreeAndNil(sql);
  FreeAndNil(MSWord);
end;
end;

procedure TfmMain.actReport2Execute(Sender: TObject);
begin
  DoReport(2);
end;

procedure TfmMain.FillReport1;
begin
    MSWord.ReplaceText('<>', SQL.FieldByName('COUNT_ALL').AsString);

    MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_WITH_GIPERTONIA').AsString);
    if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
      MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPERTONIA').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
    else MSWord.ReplaceText('<  %>', '0');

    MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_NE_OBSLED').AsString);
    if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
      MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_NE_OBSLED').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
    else MSWord.ReplaceText('<  %>', '0');

    MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_CHASTICHNO_OBSLED').AsString);
    if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
      MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_CHASTICHNO_OBSLED').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
    else MSWord.ReplaceText('<  %>', '0');

    MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_POLNOE_OBSLED').AsString);
    if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
      MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_POLNOE_OBSLED').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
    else MSWord.ReplaceText('<  %>', '0');

    MSWord.ReplaceText('<  >', SQL.FieldByName('COUNT_VPERVIE_NA_UCHET').AsString);
    if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
      MSWord.ReplaceText('<   %>', FormatFloat('0.00', SQL.FieldByName('COUNT_VPERVIE_NA_UCHET').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
    else MSWord.ReplaceText('<   %>', '0');

    MSWord.ReplaceText('<  >', SQL.FieldByName('COUNT_RANEE_UCHET').AsString);
    if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
      MSWord.ReplaceText('<   %>', FormatFloat('0.00', SQL.FieldByName('COUNT_RANEE_UCHET').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
    else MSWord.ReplaceText('<   %>', '0');

    MSWord.ReplaceText('<  >', SQL.FieldByName('COUNT_ALL_UCHET').AsString);
    if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
      MSWord.ReplaceText('<   %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ALL_UCHET').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
    else MSWord.ReplaceText('<   %>', '0');
end;

procedure TfmMain.FillReport2;
begin
  MSWord.ReplaceText('<>', SQL.FieldByName('COUNT_ALL').AsString);
  MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_WITH_GIPERTONIA').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPERTONIA').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<  %>', '0');

  MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_WITH_PREPARAT').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_PREPARAT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<  %>', '0');
end;

procedure TfmMain.actReport3Execute(Sender: TObject);
begin
  DoReport(3);
end;

procedure TfmMain.FillReport3;
begin
  MSWord.ReplaceText('<>', SQL.FieldByName('COUNT_ALL').AsString);
  MSWord.ReplaceText('<1>', SQL.FieldByName('COUNT_ALL_KURIT').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<1 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ALL_KURIT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<1 %>', '0');

  MSWord.ReplaceText('<1>', SQL.FieldByName('COUNT_ALL_ALKOGOL').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<1 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ALL_ALKOGOL').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<1 %>', '0');

  MSWord.ReplaceText('< 1>', SQL.FieldByName('COUNT_ALL_MASSA_MNOGO').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('< 1 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ALL_MASSA_MNOGO').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('< 1 %>', '0');

  MSWord.ReplaceText('< 1>', SQL.FieldByName('COUNT_ALL_MASSA_MALO').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('< 1 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ALL_MASSA_MALO').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('< 1 %>', '0');


  MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_GIPER').AsString);
  if SQL.FieldByName('COUNT_GIPER').AsFloat <> 0 then
    MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_GIPER').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<  %>', '0');

  MSWord.ReplaceText('<2>', SQL.FieldByName('COUNT_GIPER_KURIT').AsString);
  if SQL.FieldByName('COUNT_GIPER').AsFloat <> 0 then
    MSWord.ReplaceText('<2 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_GIPER_KURIT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<2 %>', '0');

  MSWord.ReplaceText('<2>', SQL.FieldByName('COUNT_GIPER_ALKOGOL').AsString);
  if SQL.FieldByName('COUNT_GIPER').AsFloat <> 0 then
    MSWord.ReplaceText('<2 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_GIPER_ALKOGOL').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<2 %>', '0');

  MSWord.ReplaceText('< 2>', SQL.FieldByName('COUNT_GIPER_MASSA_MNOGO').AsString);
  if SQL.FieldByName('COUNT_GIPER').AsFloat <> 0 then
    MSWord.ReplaceText('< 2 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_GIPER_MASSA_MNOGO').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('< 2 %>', '0');

  MSWord.ReplaceText('< 2>', SQL.FieldByName('COUNT_GIPER_MASSA_MALO').AsString);
  if SQL.FieldByName('COUNT_GIPER').AsFloat <> 0 then
    MSWord.ReplaceText('< 2 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_GIPER_MASSA_MALO').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('< 2 %>', '0');


  MSWord.ReplaceText('<>', SQL.FieldByName('COUNT_ZDOROV').AsString);
  if SQL.FieldByName('COUNT_ZDOROV').AsFloat <> 0 then
    MSWord.ReplaceText('< %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ZDOROV').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('< %>', '0');

  MSWord.ReplaceText('<3>', SQL.FieldByName('COUNT_GIPER_KURIT').AsString);
  if SQL.FieldByName('COUNT_ZDOROV').AsFloat <> 0 then
    MSWord.ReplaceText('<3 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ZDOROV_KURIT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<3 %>', '0');

  MSWord.ReplaceText('<3>', SQL.FieldByName('COUNT_GIPER_ALKOGOL').AsString);
  if SQL.FieldByName('COUNT_ZDOROV').AsFloat <> 0 then
    MSWord.ReplaceText('<3 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ZDOROV_ALKOGOL').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<3 %>', '0');

  MSWord.ReplaceText('< 3>', SQL.FieldByName('COUNT_ZDOROV_MASSA_MNOGO').AsString);
  if SQL.FieldByName('COUNT_ZDOROV').AsFloat <> 0 then
    MSWord.ReplaceText('< 3 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ZDOROV_MASSA_MNOGO').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('< 3 %>', '0');

  MSWord.ReplaceText('< 3>', SQL.FieldByName('COUNT_ZDOROV_MASSA_MALO').AsString);
  if SQL.FieldByName('COUNT_ZDOROV').AsFloat <> 0 then
    MSWord.ReplaceText('< 3 %>', FormatFloat('0.00', SQL.FieldByName('COUNT_ZDOROV_MASSA_MALO').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('< 3 %>', '0');
end;

procedure TfmMain.actReport4Execute(Sender: TObject);
begin
  DoReport(4);
end;

procedure TfmMain.FillReport4;
begin
  MSWord.ReplaceText('<>', SQL.FieldByName('COUNT_ALL').AsString);
  MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_WITH_GIPERTONIA').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPERTONIA').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<  %>', '0');

  MSWord.ReplaceText('<1 >', SQL.FieldByName('COUNT_WITH_GIPER_1STEPEN').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<1  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPER_1STEPEN').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<1  %>', '0');

  MSWord.ReplaceText('<2 >', SQL.FieldByName('COUNT_WITH_GIPER_2STEPEN').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<2  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPER_2STEPEN').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<2  %>', '0');

  MSWord.ReplaceText('<3 >', SQL.FieldByName('COUNT_WITH_GIPER_3STEPEN').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<3  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPER_3STEPEN').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<3  %>', '0');

  MSWord.ReplaceText('< >', SQL.FieldByName('COUNT_WITH_GIPER_PREPARAT').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<  %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPER_PREPARAT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<  %>', '0');

  MSWord.ReplaceText('<1  >', SQL.FieldByName('COUNT_WITH_GIPER_1PREPARAT').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<1   %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPER_1PREPARAT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<1   %>', '0');

  MSWord.ReplaceText('<2  >', SQL.FieldByName('COUNT_WITH_GIPER_2PREPARAT').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<2   %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPER_2PREPARAT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<2   %>', '0');

  MSWord.ReplaceText('<3  >', SQL.FieldByName('COUNT_WITH_GIPER_3PREPARAT').AsString);
  if SQL.FieldByName('COUNT_ALL').AsFloat <> 0 then
    MSWord.ReplaceText('<3   %>', FormatFloat('0.00', SQL.FieldByName('COUNT_WITH_GIPER_3PREPARAT').AsFloat / SQL.FieldByName('COUNT_ALL').AsFloat * 100))
  else MSWord.ReplaceText('<3   %>', '0');

end;

function TfmMain.CheckForBadDocument: integer;
var tmp: TQuery;
begin
  tmp := TQuery.Create(Self);
  tmp.DatabaseName := txtPath.Caption;
  //      
  tmp.SQL.Text := 'select count(document.doclid) from document left join person on person.prnlid = document.prnlid where person.prnlid is null';
  tmp.Open;
  Result := tmp.Fields[0].AsInteger; //      
end;

end.
